Purpose
=======

The purpose of this project is to provide a solid frontend development starting template. It focuses on being minimal while still being complete enough for today's responsive, mobile, client-side application needs.


Live Example
============

The current HEAD can be viewed over at http://files.zenpirate.com/FrontendDevelopmentTemplates/

Current Version
=============

This project combines Ember.js and Skeleton CSS then places both of those tools on top of a stripped down and minified HTML5 Boilerplate. It has the following features:

1. It is loosely based on the HTML5 Boilerplate project. This means it's already using a bunch of best practices for code layout.
2. It provides Skeleton as an ultra lightweight replacement for Twitter Bootstrap. This provides a nice minimal style guide while still being extremely responsive.
3. It provides Ember.js as a "better" replacement for Backbone.js. This makes the headaches of Backbone.js go away even if your project is REALLY tiny.

Code written using this project shouldn't have any issues integrating cleanly into a Rails or Node.js/Express environment.

History of this Repository / Past Template Attempts
=======

For a while this repository was a dumping ground for a few half-hearted attempts at various development templates for client-side canvas games.

Over time, I realized that I still didn't have a truly useable front end development template because most of the projects I was planning to build were not in the direction of Javascript games. Furthermore, all of those templates focused too much on the javascript tools involved, instead of the "getting things done" part. 

So, over the last year or so the schizophrenically created, entirely messy, JS code examples - while covering a pretty good cross section of ideas and tools - have been moved to their own branches. These "templates" included bits and pieces of Raphael.js, Backbone.js/Underscore, and Agility.js (customized to support serverside templates), along with some customized debugging and helper libraries I wrote myself.

Perhaps one day these tools will be expanded upon to create a more useable Javascript game template but for now, if you're interested in such things, you'll have to check out those various branches.

I've tried to add a bit of information to the README files of each branch but take them all with a grain of salt.
